#include "tcp.h"
#include "udp.h"
#include <cstring>

#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif
#include <sys/types.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <netdb.h>

// Usage:
//   ncp host files
//     ...to send files
//   ncp
//     ...to receive files
//   npoll host
//     ...to get files
//   npush files
//     ...to push files

main(int argc,char *argv[]) {
  pid_t PID=0;
  bool poll=false;
  char *myname=argv[0],*tmp=strrchr(myname,'/');
  if (tmp) myname=tmp+1;
  try {
    if (!strcmp(myname,"npush")) {
      char **cmdline=new char* [argc+5];
      cmdline[0]="tar";
      cmdline[1]="cpSvvf";
      cmdline[2]="-";
      for (int i=1; i<=argc; i++)
	cmdline[i+2]=argv[i];
      pid_t PID;
//      int socketfd=selectable_server_socket_magic(8002,INADDR_ANY);
      int tmps=selectable_server_socket_magic(8002,INADDR_ANY);
      bool done=false;
      char rnd[10];
      srandom(getpid()+getppid()+time(0));
      sprintf(rnd,"S%x",random());
      int s=udp_socket_magic(8002);
      do {
	struct sockaddr_in to;
	to.sin_family=AF_INET;
	to.sin_port=htons(8002);
	to.sin_addr.s_addr=0xffffffff;
	fd_set r,w,x;
	FD_ZERO(&r); FD_ZERO(&w); FD_ZERO(&x);
	FD_SET(tmps,&r); FD_SET(tmps,&w); FD_SET(s,&r);
	struct timeval timeout;
	timeout.tv_sec=0;
	timeout.tv_usec=200000;
	sendto(s,rnd,9,0,(sockaddr*)&to,sizeof(to));
	switch (select(tmps+1,&r,&w,&x,&timeout)) {
	  case -1:
	    perror("select");
	    exit(1);
	  case 0:
//	    printf("waiting...\n");
	    break;
	  default:
	    if (FD_ISSET(s,&r)) {
	      printf("got UDP packet\n");
	      char peerip[100];
	      char buf[1024];
	      int received=0;
	      struct sockaddr_in from;
	      int fromlen=sizeof(from);
	      received=recvfrom(s,buf,1023,0,(sockaddr*)&from,&fromlen);
	      unsigned long peer=ntohl(from.sin_addr.s_addr);
	      sprintf(peerip,"%d.%d.%d.%d",
		    (peer&0xff000000)>>24,(peer&0x00ff0000)>>16,
		    (peer&0x0000ff00)>>8,(peer&0x000000ff));
	      if (buf[0]=='R') {
		sendto(s,rnd,9,0,(sockaddr*)&to,sizeof(to));
	      }
	    }
	    if (FD_ISSET(tmps,&r)) {
//	      printf("ready to accept\n");
	      done=true;
	    }
	    break;
	}
      } while (!done);
      struct sockaddr_in sa;
      int addrlen=sizeof(sa);
      int socketfd=accept(tmps,(struct sockaddr *)&sa,&addrlen);
      {
	struct sockaddr_in sa;
	int sasize=sizeof(sa);
	if (getpeername(socketfd,(sockaddr*)&sa,&sasize)==0) {
	  unsigned long peer=ntohl(sa.sin_addr.s_addr);
	  struct hostent *host;
	  if ((host=gethostbyaddr((char *)&sa.sin_addr,sizeof(struct in_addr),AF_INET)))
	    printf("Connection from %s (%d.%d.%d.%d)\n",
		   host->h_name,
		   (peer&0xff000000)>>24,(peer&0x00ff0000)>>16,
		   (peer&0x0000ff00)>>8,(peer&0x000000ff));
	  else
	    printf("Connection from %d.%d.%d.%d\n",
		   (peer&0xff000000)>>24,(peer&0x00ff0000)>>16,
		   (peer&0x0000ff00)>>8,(peer&0x000000ff));
	}
      }
      int tarfd=pipe_magic("tar",cmdline,PID,true,false);
      for (;;) {
	int tmp;
	char buf[4096];
	tmp=read(tarfd,buf,4095);
	write(socketfd,buf,tmp);
	if (tmp<=0)
	  break;
      }
      close(socketfd);
      close(tarfd);
    } else if (!strcmp(myname,"npoll")) {
      char **cmdline=new char* [4];
      cmdline[0]="tar";
      cmdline[1]="xvvpSf";
      cmdline[2]="-";
      cmdline[3]=0;
      int socketfd;
      if (argv[1]) {
	socketfd=client_socket_magic(argv[1],8002);
      } else {
	int s=udp_socket_magic(8002);
	char peerip[100];
	char buf[1024];
	int received=0;
	struct sockaddr_in from;
	int fromlen=sizeof(from);
	do {
	  received=recvfrom(s,buf,1023,0,(sockaddr*)&from,&fromlen);
	} while (received<8);
	unsigned long peer=ntohl(from.sin_addr.s_addr);
	sprintf(peerip,"%d.%d.%d.%d",
	      (peer&0xff000000)>>24,(peer&0x00ff0000)>>16,
	      (peer&0x0000ff00)>>8,(peer&0x000000ff));
	{
	  struct hostent *host;
	  if ((host=gethostbyaddr((char *)&from.sin_addr,sizeof(struct in_addr),AF_INET)))
	    printf("Saw advertisement from %s (%d.%d.%d.%d)\n",
		   host->h_name,
		   (peer&0xff000000)>>24,(peer&0x00ff0000)>>16,
		   (peer&0x0000ff00)>>8,(peer&0x000000ff));
	  else
	    printf("Saw advertisement from %d.%d.%d.%d\n",
		   (peer&0xff000000)>>24,(peer&0x00ff0000)>>16,
		   (peer&0x0000ff00)>>8,(peer&0x000000ff));
	}
	socketfd=client_socket_magic(peerip,8002);
      }
      int tarfd=pipe_magic("tar",cmdline,PID,false,true);
      for (;;) {
	int tmp;
	char buf[4096];
	tmp=read(socketfd,buf,4095);
	write(tarfd,buf,tmp);
	if (tmp<=0)
	  break;
      }
      close(socketfd);
      close(tarfd);
    } else {
      char **cmdline=new char* [argc+4];
      if (argc<2) {
	cerr << "Server mode" << endl;
	cmdline[0]="tar";
	cmdline[1]="xvvpSf";
	cmdline[2]="-";
	cmdline[3]=0;
	int socketfd=server_socket_magic(8002,INADDR_ANY);
	int tarfd=pipe_magic("tar",cmdline,PID,false,true);
	for (;;) {
	  int tmp;
	  char buf[4096];
	  tmp=read(socketfd,buf,4095);
	  write(tarfd,buf,tmp);
	  if (tmp<=0)
	    break;
	}
	close(socketfd);
	close(tarfd);
      } else {
	cerr << "Client mode" << endl;
	cmdline[0]="tar";
	cmdline[1]="cpSvvf";
	cmdline[2]="-";
	for (int i=2; i<=argc; i++)
	  cmdline[i+1]=argv[i];
	pid_t PID;
	int socketfd=client_socket_magic(argv[1],8002);
	int tarfd=pipe_magic("tar",cmdline,PID,true,false);
	for (;;) {
	  int tmp;
	  char buf[4096];
	  tmp=read(tarfd,buf,4095);
	  write(socketfd,buf,tmp);
	  if (tmp<=0)
	    break;
	}
	close(socketfd);
	close(tarfd);
      }
    }
  } catch (NetworkError &e) {
    if (PID) {
      kill(PID,15);
      waitpid(PID,0,0);
    }
    cerr << e << endl;
  }
  return 0;
}
