#include "config.h"

#include <netinet/in.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#ifdef HAVE_SYS_WAIT_H
#include <sys/wait.h>
#endif

#include <fstream.h>

struct NetworkError {
  int Errno;
  const char *message;
  NetworkError(const char *Message,int errornumber) {
    message=Message;
    Errno=errornumber;
  }
//  NetworkError(const char *Message,int errornumber) :
//    message(Message), Errno(errornumber) { }
};

ostream& operator<<(ostream &o,const NetworkError &e);

struct DNSError {
  DNSError() { }
};

class tcpstream : public fstream {
public:
  tcpstream(const char *hostname,short port);
  tcpstream(short port);
};

class pipestream : public fstream {
  pid_t PID;
public:
  pipestream(const char *program,char *const commandline[]);
  ~pipestream();
};

int server_socket_magic(short port,long addr);
int selectable_server_socket_magic(short port,long addr);
int client_socket_magic(const char *host,short port);
int pipe_magic(const char *program,char *const commandline[],pid_t &PID,
	       bool read=true,bool write=true);
