#include "config.h"

#define _XOPEN_SOURCE
#define __EXTENSIONS__
#include <sys/types.h>
#include <sys/socket.h>
#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif
#include <netinet/in.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef HAVE_FCNTL_H
#include <fcntl.h>
#endif
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/wait.h>

#include <fstream.h>

#include "tcp.h"

#ifndef O_NDELAY
#ifdef O_NONBLOCK
#define O_NDELAY O_NONBLOCK
#else
#error neither O_NDELAY nor O_NONBLOCK is defined!  Please fix the includes.
#endif
#endif

/* Open a server socket, return a file descriptor ready for accept() or
 * select() or -1 on error.  The socket is set to non-blocking I/O and
 * address reuse. */
int udp_socket_magic(short port,long addr) {
/* e.g.: port=80, addr=INADDR_ANY */
  static int True=1;	/* needed for setsockopt :( */
  int s;
  struct sockaddr_in sa;
  if ((s=socket(AF_INET,SOCK_DGRAM,IPPROTO_UDP))==-1)
    throw NetworkError("socket",errno);
//  if (fcntl(s,F_SETFL,O_NDELAY)==-1) {
//    perror("fcntl");
//    return -1;
//  }
  if (setsockopt(s,SOL_SOCKET,SO_REUSEADDR,(void *)&True, sizeof(True))==-1)
    throw NetworkError("setsockopt(SO_REUSEADDR)",errno);
  if (setsockopt(s,SOL_SOCKET,SO_BROADCAST,(void *)&True, sizeof(True))==-1)
    throw NetworkError("setsockopt(SO_BROADCAST)",errno);
  sa.sin_family=AF_INET;
  sa.sin_port=htons(port);
  sa.sin_addr.s_addr=addr;
  if (bind(s,(struct sockaddr *)&sa,sizeof(sa))==-1)
    throw NetworkError("bind",errno);
  return s;
}

/* Trivial DNS lookup routine that accepts a string that can contain a
 * host name or IP address and returns 0 or the host address in network
 * order. */
unsigned long DNSLookup2(const char *Host) {
  struct hostent *he;
  if ((he = gethostbyname(Host)) == NULL)
    if ((he = gethostbyaddr(Host, strlen(Host), AF_INET)) == NULL)
      throw DNSError();
  return *(long*)(he->h_addr_list[0]);
}

